#lang play
#|

<prog> ::= {<def>* <expr>}
 
<def> ::= {deftype <id> {<id> : <type>}+}
        | {def <id> {<id> : <type>}* : <type> <expr>}
 
<type> ::= <id>
         | {<type>+ -> <type>}
 
<expr> ::= <id>
         | {fun {<id> : <type>}+ <expr>}
         | {match <expr> {<case>+}}
         | {<expr> <expr>*}
 
<case> ::= {case <pattern> => <expr>}
 
<pattern> ::= <id>
            | {<id> <id>*}
|#

;;;;;;;;;;;;;;
;; P1
;;;;;;;;;;;;;;
  
;parser :: s-expr -> Expr
(define (parser s-expr)
  (void))

;interp :: Expr x Env -> Val
(define (interp expr env)
  (void))

;run :: s-expr -> String 
(define (run s-expr)
  (void))
 
;;;;;;;;;;;;;;
;; P2
;;;;;;;;;;;;;;


;terminate :: s-expr → String 
(define (terminate s-expr)
  (void))